var arrSuggestion = [];

$(document).ready(function() {

  /* Init */

  initTooltips();
  initVideoChannel();
  initZoneTabComponent();
  initServiceId();

  /* CustomBox fields */

  // Fill CustomBox form

  $('#customBoxColor').val(rgbToHex(serviceArrTmp[activeItem].customAreaColor));
  $('#colorPaletteForCustomBoxColor').val(rgbToHex(serviceArrTmp[activeItem].customAreaColor));
  var opacity = (serviceArrTmp[activeItem].customAreaColor.split(','))[3];
  $('#customBoxOpacity').val(opacity*100);
  $('#customBoxWidth').val(serviceArrTmp[activeItem].customAreaWidth);
  $('#customBoxHeight').val(serviceArrTmp[activeItem].customAreaHeight);
  $('#customBoxCorners').val(serviceArrTmp[activeItem].customAreaCorners);

  attachEventsToCustomBox();

  /* End CustomBox fields */

  // CustomBox image

  $('#textAndBackgroundImage').on('change', function() {
    initMappingAreaType($('#textAndBackgroundMappingArea').val());
  });

  /* Fill form */
  Switch().init('textAndBackgroundEnabled');

  $('#textAndBackgroundCustomName')
    .val(serviceArrTmp[activeItem].customName || '')
    .keyup(onCustomNameKeyUp)
    .attachValidation({
      pattern: '^[A-Za-z0-9 -]{0,}$',
      invalidMsg: 'Only chars A-Z, a-z, 0-9, white space and dash are allowed.',
      disableBtnId: 'saveBtn'
    });
  $('#textAndBackgroundPosX').val(serviceArrTmp[activeItem].pos_x);
  $('#textAndBackgroundPosY').val(serviceArrTmp[activeItem].pos_y);

  // Create image list field
  createImageList('#textAndBackgroundImage', false, serviceArrTmp[activeItem].image);

  // Change image list filed after close image modal
  $('body').off('hide.bs.modal').on('hide.bs.modal', '#fileManagerModal', function() {
    createImageList('#textAndBackgroundImage', false, serviceArrTmp[activeItem].image);
    initZoneTabComponent();
  });

  // Mapping area

  var mappingArea = serviceArrTmp[activeItem].background;
  var inputGroupImage = $('#textAndBackgroundImage').closest('.input-group');
  $('#textAndBackgroundMappingArea').val(mappingArea);
  (mappingArea === 'image') ? inputGroupImage.removeClass('d-none') : inputGroupImage.addClass('d-none');

  $('#textAndBackgroundMappingArea').on('change', function() {
    mappingArea = $('#textAndBackgroundMappingArea').val();
    (mappingArea === 'image') ? inputGroupImage.removeClass('d-none') : inputGroupImage.addClass('d-none');
    initMappingAreaType(mappingArea);
  });

  // Clock format

  if (serviceArrTmp[activeItem].clockFormat !== undefined) {
    $('#textAndBackgroundRadioClock').val(serviceArrTmp[activeItem].clockFormat).change();
  }

  // Create list fields
  const resolutionId = '#textAndBackgroundResolution';
  const videoChannelId = '#textAndBackgroundVideoChannel';
  createResolutionList(resolutionId);
  createPositionList('#textAndBackgroundPosition', serviceArrTmp[activeItem].coordSystem);
  createTriggeringElement('#textAndBackgroundAutomationType', serviceArrTmp[activeItem].automationType, serviceArrTmp[activeItem].schedule);
  onVideoChannelChange(resolutionId, videoChannelId, serviceArrTmp[activeItem].camera);
  createVideoChannelElement(videoChannelId, serviceArrTmp[activeItem].camera).then(function() {
    // Callbacks for changes
    $('.form-control').change(formChangedCallback);
    $('.form-control-inline').change(formChangedCallback);

    formChangedCallback();
  });

  // Import & export configuration
  configExport();
  configImport();

  // Align items
  $('.alignTo').on('click', function() {
    alignTo($(this));
  });

  createScheduleBtn();
});

/*******************************************************/
/*                 Alignment of .boxIn                 */
/*******************************************************/
function alignTo(element) {
  var place = element.attr('data-align');
  var activeItems = $('.boxIn.active');

  var names = [];
  activeItems.each(function () {
    names.push($(this).attr('data-name'));
  });

  var boxes = [];

  for (var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    var tabName = serviceArrTmp[activeItem].mappingZones[i].name;
    for (var o = 0; o < names.length; o++) {
      if (names[o] === tabName) {
        boxes.push({
          name: tabName,
          pos_x: serviceArrTmp[activeItem].mappingZones[i].pos_x,
          pos_y: serviceArrTmp[activeItem].mappingZones[i].pos_y,
          font_size: serviceArrTmp[activeItem].mappingZones[i].fontSize,
          text_lines: serviceArrTmp[activeItem].mappingZones[i].textLines
        });
      }
    }
  }

  if(activeItems.length < 2){
    // align one .boxIn item in mappingArea
    if (place === 'bottom') {
      boxes[0].pos_y = serviceArrTmp[activeItem].customAreaHeight - (boxes[0].text_lines * boxes[0].font_size + 16);
    } else if(place === 'top') {
      boxes[0].pos_y = 0;
    } else if(place === 'center') {
      boxes[0].pos_y = (serviceArrTmp[activeItem].customAreaHeight / 2) - ((boxes[0].text_lines * boxes[0].font_size + 16)/ 2);
    }
  } else {
    // align multiple .boxIn items in mappingArea

    if (place === 'bottom') {
      var longestDistance = 0;
      for (i = 0; i < boxes.length; i++) {
        if (longestDistance < boxes[i].pos_y) {
          longestDistance = boxes[i].pos_y;
        }
      }
      //calculate pos_y for other elements
      for (i = 0; i < boxes.length; i++) {
        if (boxes[i].text_lines > 1) {
          boxes[i].pos_y = longestDistance - (boxes[i].text_lines * boxes[i].font_size);
        } else {
          boxes[i].pos_y = longestDistance - (boxes[i].font_size);
        }
      }
    } else if (place === 'top') {
      var shortestDistance = 99999;
      for (i = 0; i < boxes.length; i++) {
        if (shortestDistance > boxes[i].pos_y) {
          shortestDistance = boxes[i].pos_y;
        }
      }
      //calculate pos_y for other elements
      for (i = 0; i < boxes.length; i++) {
        boxes[i].pos_y = shortestDistance;
      }
    } else if (place === 'center') {
      var avgDistance = 0;
      var sumDistance = 0;
      //calculate sum and then avg
      for (i = 0; i < boxes.length; i++) {
        sumDistance += boxes[i].pos_y;
      }
      avgDistance = sumDistance / boxes.length;
      //calculate pos_y for all elements
      for (i = 0; i < boxes.length; i++) {
        if (boxes[i].text_lines > 1) {
          boxes[i].pos_y = avgDistance - ((boxes[i].text_lines * boxes[i].font_size) / 2);
        } else {
          boxes[i].pos_y = avgDistance - (boxes[i].font_size / 2);
        }
      }
    }
  }
  //set new pos_y to all active .boxIn
  setNewPosY(boxes);

  formChangedCallback();
  initMappingAreaType($('#textAndBackgroundMappingArea').val());
}

function setNewPosY(boxes) {
  for (var o = 0; o < boxes.length; o++) {
    for (var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
      if (boxes[o].name === serviceArrTmp[activeItem].mappingZones[i].name) {
        $('#textAndBackgroundText'+boxes[o].name+'PosY').val(boxes[o].pos_y);
      }
    }
  }
}

/*******************************************************/
/*                     customBox                       */
/*******************************************************/

// Attach events
function attachEventsToCustomBox() {

  // Opacity input change text with %
  $('#customBoxOpacity').next().find('.input-group-text').first().text($('#customBoxOpacity').val());
  $('#customBoxOpacity').on('change mousemove', function() {
    $(this).next().find('.input-group-text').first().text($(this).val());
  });

  // Color palette changing input text color
  $('#colorPaletteForCustomBoxColor').off('change').on('change',function() {
    $('#customBoxColor').val($(this).val());
  });

  // Input text color changing palette
  $('#customBoxColor').off('change').on('change',function() {
    $('#colorPaletteForCustomBoxColor').val($(this).val());
  });

  // Check min width value
  $('#customBoxWidth').on('change', function() {
    var minWidth = getMinWidth();
      if($(this).val() <= minWidth) {
        validate($(this), $(this).val(), 'Current positions of fields require a width of ' + minWidth + "px.");
      } else {
        $(this).closest('.input-group').find('.invalid-feedback').remove();
        $(this).removeClass('is-invalid');
      }
  });

  // Check min height value
  $('#customBoxHeight').on('change', function() {
    var minHeight = getMinHeight();
    if($(this).val() <= minHeight) {
      validate($(this), $(this).val(), 'Current positions of fields require a height of ' + minHeight + "px.");
    } else {
      $(this).closest('.input-group').find('.invalid-feedback').remove();
      $(this).removeClass('is-invalid');
    }
  });

  // Save btn
  $('#customBoxSave').on('click', function() {
    saveCustomBoxSettings();
    initMappingAreaType($('#textAndBackgroundMappingArea').val());
  });
}

// Save all fields from customBox
function saveCustomBoxSettings() {
  serviceArrTmp[activeItem].customAreaColor = joinColorAndOpacity($('#customBoxColor'), $('#customBoxOpacity'));
  serviceArrTmp[activeItem].customAreaWidth = parseInt($('#customBoxWidth').val());
  serviceArrTmp[activeItem].customAreaHeight = parseInt($('#customBoxHeight').val());
  serviceArrTmp[activeItem].customAreaCorners = $('#customBoxCorners').val();
}

/*******************************************************/
/*                   mappingArea                       */
/*******************************************************/

// Init
function initMappingAreaType(type) {
  var mappingAreaType = $('#mappingAreaType');
  mappingAreaType.showSpinner();

  setTimeout(function() {
    if(type === 'image') {
      mappingAreaTypeSetHeader(type, 'Image');
    } else {
      mappingAreaTypeSetHeader(type, 'Custom Box');
    }
    mappingAreaTypeSetSource(mappingAreaType, type);
    drawAll(mappingAreaType);
    mappingAreaType.hideSpinner();

  }, 800);
}

// Set header to mappingArea
function mappingAreaTypeSetHeader(type, label) {
  var elementLabel = $('#mappingAreaLabel');
  var elementLabelInfo = $('#mappingAreaInfo');
  var settingsBtn = $('#customBoxSettings');

  if(type === 'image') {
    elementLabel.text('Image');
    elementLabelInfo.text('');
    settingsBtn.hide();
  } else {
    settingsBtn.show();
    elementLabel.text(label);
    if ($('#customBoxWidth').val() && $('#customBoxHeight').val()) {
      elementLabelInfo.text('(Resolution: ' + $('#customBoxWidth').val() + ' x ' + $('#customBoxHeight').val() + ' px)');
    }
  }
}

// Set source to mappingArea
function mappingAreaTypeSetSource(elementMappingAreaType, type) {
  var image = elementMappingAreaType.find('#image');
  var div = elementMappingAreaType.find('#customBox');

  if(type === 'image') {
    div.hide();
    image
      .attr('src', '/local/camoverlay/api/image.cgi?path=' + encodeURIComponent('file://' + $('#textAndBackgroundImage').val()) + '&_t=' + Date.now())
      .show();
  } else {
    image.hide();
    var bgColor = 'rgba(' + joinColorAndOpacity($('#customBoxColor'), $('#customBoxOpacity')) + ')';
    div.css({
      backgroundColor: bgColor,
      width: $('#customBoxWidth').val(),
      height: $('#customBoxHeight').val(),
      borderRadius: ($('#customBoxCorners').val() === 'rounded') ? '5px' : '0px'
    })
      .show();
  }
  elementMappingAreaType.css('min-height', getMinHeight()+20); //set min height of mappingArea
}

/*******************************************************/
/*                 TextTab component                   */
/*******************************************************/

// Init
function initTextTabComponent() {
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    var tabName = serviceArrTmp[activeItem].mappingZones[i].name;
    createTextTabContent('#textTabContent' + tabName, tabName, i);
    createTextTabs('#textTabs' + tabName, tabName, i);

    makeActiveTextTab(tabName, i); // Make TextTab item active
    attachEventsToTextTabComponent(tabName, i); // Attach events
  }
}

// Create TextTabs
function createTextTabs(elementID, tabName, tabID) {
  var textButtonAdd = '<li class="nav-item ml-auto"><a href="" class="btn btn-sm btn-secondary ml-4 mt-1 addText addText-'+tabName+'" role="tab" aria-controls="add" data-tab-name="' + tabName + '" aria-selected="false" title="Another text variant for Control Room."><span class="fa fa-plus-circle"></span></a></li>';
  var textTabs = '';
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones[tabID].text.length; i++) {
    var textTabName = 'text' + (i+1);
    var textTab = '<li class="nav-item"><a class="nav-link" style="position: relative;cursor: pointer;" id="Source' + textTabName + '" data-text-id="' + i + '" data-parent-tab-name="' + tabName + '" data-tab-name="' + textTabName + '" data-toggle="tab" href="#source-' + tabName + '-' + textTabName + '" role="tab" aria-controls="source-' + tabName + '-' + textTabName + '" aria-selected="false">';
    textTab += '<span style="white-space: nowrap;text-overflow: ellipsis;max-width: 100px;display: inline-flex;overflow: hidden; padding-right: 12px;">' + textTabName + '</span>';
    if(i !== 0) textTab += '<span class="ml-2 text-remove removeSource" data-text-id="' + i + '" data-tab-name="' + tabName + '"><span class="removeSourceIcon ml-2 fas fa-times"></span></span></a></li>';
    textTabs += textTab;
  }
  textTabs += textButtonAdd;
  $(elementID).html(textTabs);
}

// Create TextTabContent
function createTextTabContent(elementID, tabName, tabID) {
  var textTabContentAll = '';
  for(var o = 0; o < serviceArrTmp[activeItem].mappingZones[tabID].text.length; o++) {
    var item = '<div class="tab-pane fade" id="source-%TAB_ID%-%TEXT_ID%" role="tabpanel" aria-labelledby="source-%TAB_ID%-%TEXT_ID%"><div class="row"><div class="col-lg-12">';
    item +=
      '<textarea class="form-control" rows="2" id="textAndBackgroundText%TAB_ID%InputText%TEXT_ID%" data-text-id="%TEXT_ID%" data-tab-name="%TAB_ID%" placeholder="Use enter to break the lines"></textarea>\n' +
      '<small class="text-muted">Variables for text: #date, #dateus, #dateuk, #time12, #time24, #timesec</small>\n' +
      '<small class="wrapMsg text-danger float-left w-100" data-tab-name="%TAB_ID%" data-text-id="%TEXT_ID%" style="height: 14px;"></small>';
    item = item.split('%TAB_ID%').join(serviceArrTmp[activeItem].mappingZones[tabID].name);
    item = item.split('%TEXT_ID%').join("text"+(o+1));
    item += '</div></div></div>';
    textTabContentAll += item;
  }
  $(elementID).html(textTabContentAll);
}

// Make TextTab item active
function makeActiveTextTab(tabID, i) {
  var foundActive = false;
  for(var o = 0; o < serviceArrTmp[activeItem].mappingZones[i].text.length; o++) {
    if(serviceArrTmp[activeItem].mappingZones[i].name === tabID) {
      if (serviceArrTmp[activeItem].mappingZones[i].text[o].active) {
        foundActive = true;
        $('#textTabs' + tabID + ' li a[id="Sourcetext' + (o + 1) + '"]').tab('show');
      }
    }
  }
  if(!foundActive) {
    $('#textTabs' + tabID + ' li:first-child a').tab('show');
  }
}

// Fill textTab component
function fillTextTabContent(tabID, elementPrefix) {
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones[tabID].text.length; i++) {
    var element = 'text' + (i+1);
    $(elementPrefix + 'InputText' + element).val(serviceArrTmp[activeItem].mappingZones[tabID].text[i].source);
  }
}

// Save textTab component's values
function saveTextTabContent(tabID, elementPrefix) {
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones[tabID].text.length; i++) {
    var element = 'text' + (i+1);
    serviceArrTmp[activeItem].mappingZones[tabID].text[i].source = $(elementPrefix + 'InputText' + element).val();
  }
}

// Attach events to TextTabComponent
function attachEventsToTextTabComponent(tabName, i) {

  // Add textTab
  $('.addText-'+tabName).off('click').on('click', function(e) {
    e.preventDefault();
    var newTextTabId = serviceArrTmp[activeItem].mappingZones[i].text.length + 1;
    var tabName = $(this).attr('data-tab-name');
    var newText = { source: "", active: true };
    // Set previous text to not active
    for(var o = 0; o < serviceArrTmp[activeItem].mappingZones[i].text.length; o++) {
      if (serviceArrTmp[activeItem].mappingZones[i].name === tabName) {
        serviceArrTmp[activeItem].mappingZones[i].text[o].active = false;
      }
    }
    serviceArrTmp[activeItem].mappingZones[i].text.push(newText);
    initZoneTabComponent(tabName);
    formChangedCallback();
  });

  // Delete textTab
  $('.removeSource').off('click').on('click', function(e) {
    e.preventDefault();
    var textID = parseInt($(this).attr('data-text-id'));
    var tabName = $(this).attr('data-tab-name');
    removeTextTab(tabName, parseInt(textID));
    $('#Sourcetext'+textID).off('click');
  });

  // Set and save active textTab
  $('.nav-link[id^="Sourcetext"]').off('click').on('click', function(e) {
    //search for .nav-link because of .removeSource inside that trigger
    if(e.currentTarget.className === "nav-link") {
      var textID = parseInt($(this).attr('data-text-id'));
      var tabName = $(this).attr('data-parent-tab-name');
      for (var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
        if (serviceArrTmp[activeItem].mappingZones[i].name === tabName) {
          for (var o = 0; o < serviceArrTmp[activeItem].mappingZones[i].text.length; o++) {
            serviceArrTmp[activeItem].mappingZones[i].text[o].active = (textID === o);
          }
        }
      }
      formChangedCallback();
    }
  });

  // On load textarea show hide wrapping msg
  var tabTextId = getActiveText(tabName);
  var element = $('textarea[data-tab-name="' + tabName + '"][data-text-id="' + tabTextId + '"]');
  var show = false;
  setTimeout(function() { // wait for load
    if(element.val().indexOf("\n") > -1 && $('.wrapText[data-tab-name="' + tabName + '"]').val() === 'false') show = true;
    toggleWrapMsg(tabName, tabTextId, show);
  }, 1000);

  // On change and type in textarea
  $('textarea[id^="textAndBackgroundText"]')
    .off('change').on('change', function() { // On change textarea save text
    saveAllZoneTabs();
  }).off('keyup').on('keyup', function() { // On typing in textarea show/hide wrapping msg
    var tabName = $(this).attr('data-tab-name');
    var tabTextId = $(this).attr('data-text-id');
    var show = false;
    if($(this).val().indexOf("\n") > -1 && $('.wrapText[data-tab-name="' + tabName + '"]').val() === 'false') show = true;
    toggleWrapMsg(tabName, tabTextId, show);
  });
}

// Remove TextTab item from tabs (second level tabs)
function removeTextTab(tabName, removeItemIndex) {
  $('#removeTextTabText').html('Do you really want to remove the <b>text' + (parseInt(removeItemIndex)+1) + '</b>?');
  $('#removeTextTab').modal('show');

  $('#removeTextTabBtn').off('click').on('click', function() {
    saveAllZoneTabs(); //save unsaved zones before remove
    for (var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
      if(tabName === serviceArrTmp[activeItem].mappingZones[i].name) {
        var newArray = [];
        for (var o = 0; o < serviceArrTmp[activeItem].mappingZones[i].text.length; o++) {
          if (removeItemIndex !== o) {
            newArray.push(serviceArrTmp[activeItem].mappingZones[i].text[o]);
          }
        }
        newArray = detectNoActiveItem(newArray); //detect no active item, set last one active
        serviceArrTmp[activeItem].mappingZones[i].text = newArray;
      }
    }
    initZoneTabComponent(tabName);
    formChangedCallback();
  });
}

/***************************************************************/
/*                      ZoneTab component                      */
/***************************************************************/

// Init
function initZoneTabComponent(activeZoneTab = '') {
  const customBoxContentJqueryElement = $('#customBoxContent');
  setMinHeightFromCurrentHeight(customBoxContentJqueryElement); // avoid jumping page in FF
  createZoneTabContent('#customBoxContent');
  createZoneTabs('#customBoxTabs');
  if(activeZoneTab === '') { //not selected tab, choose first
    $('#customBoxTabs li:first-child a').tab('show');
  } else {
    setActiveZoneTab(activeZoneTab);
  }
  // Init TextTab component
  initTextTabComponent();
  // Fill all fields in ZoneTabContent
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    fillZoneTabContent(i);
  }
  // Attach events to ZoneTab
  attachEventsToZoneTabComponent();
}

function setMinHeightFromCurrentHeight (jqueryElement) {
  let minHeight = jqueryElement.height();
  jqueryElement.css('min-height', minHeight);
}

// Create ZoneTabs (first level tabs)
function createZoneTabs(elementID) {
  var zoneButtonAdd = '<li class="nav-item ml-auto"><a href="" class="btn btn-sm btn-secondary ml-4 mt-1" id="addField" role="tab" aria-controls="add" aria-selected="false"><span class="fa fa-plus-circle mr-2"></span> Add field</a></li>';
  var zoneTabs = '';
  for (var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    var zoneTabName = serviceArrTmp[activeItem].mappingZones[i].name;
    var zoneTab = '<li class="nav-item"><a class="nav-link" style="position: relative;" id="LinkToText' + zoneTabName + '" data-tab-name="' + zoneTabName + '" data-toggle="tab" href="#text-' + zoneTabName + '" role="tab" aria-controls="text-' + zoneTabName + '" aria-selected="false">';
    zoneTab += '<span style="white-space: nowrap;text-overflow: ellipsis;max-width: 100px;display: block;overflow: hidden; padding-right: 12px;">' + zoneTabName + '</span><span class="ml-2 text-remove removeLinkToText" data-tab-name="' + zoneTabName + '"><span class="removeLinkToTextIcon ml-2 fas fa-times"></span></span></a></li>';
    zoneTabs += zoneTab;
  }
  zoneTabs += zoneButtonAdd;
  $(elementID).html(zoneTabs);
}

// Create content of ZoneTab
function createZoneTabContent(elementID) {
  var zoneTabContentAll = '';
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    var item = $('#textTabPattern').html();
    zoneTabContentAll += item.split('%TAB_ID%').join(serviceArrTmp[activeItem].mappingZones[i].name);
  }
  $(elementID).html(zoneTabContentAll);
}

// Fill ZoneTab content
function fillZoneTabContent(tabID) {
  var tabName = serviceArrTmp[activeItem].mappingZones[tabID].name;
  var elementPrefix = '#textAndBackgroundText'+tabName;
  // First column
  const tabNameField = $(elementPrefix + 'Name');
  tabNameField.val(serviceArrTmp[activeItem].mappingZones[tabID].name);
  tabNameField.attachValidation({
    pattern: '^[A-Za-z0-9]{0,}$',
    invalidMsg: 'Only chars A-Z, a-z, 0-9 are allowed.',
    disableBtnId: 'saveBtn'
  });
  $(elementPrefix + 'PosX').val(serviceArrTmp[activeItem].mappingZones[tabID].pos_x);
  $(elementPrefix + 'PosY').val(serviceArrTmp[activeItem].mappingZones[tabID].pos_y);
  fillTextTabContent(tabID, elementPrefix); // fill all text fields
  $(elementPrefix + 'WrapText option[value="'+serviceArrTmp[activeItem].mappingZones[tabID].wrapText+'"]').prop('selected', true);
  // Second column
  $(elementPrefix + 'Width').val(serviceArrTmp[activeItem].mappingZones[tabID].textWidth).change();
  $(elementPrefix + 'Color').val(rgbToHex(serviceArrTmp[activeItem].mappingZones[tabID].textColor));
  $('#colorPaletteForText' + tabName + 'Color').val(rgbToHex(serviceArrTmp[activeItem].mappingZones[tabID].textColor));
  createFontList(elementPrefix + 'TextType', serviceArrTmp[activeItem].mappingZones[tabID].font);
  $(elementPrefix + 'FontSize').val(serviceArrTmp[activeItem].mappingZones[tabID].fontSize);
  $(elementPrefix + 'Align option[value="'+serviceArrTmp[activeItem].mappingZones[tabID].textAlign+'"]').prop('selected', true);
  $(elementPrefix + 'VAlign option[value="'+serviceArrTmp[activeItem].mappingZones[tabID].textVerticalAlign+'"]').prop('selected', true);
  $(elementPrefix + 'NumberOfLines').val(parseInt(serviceArrTmp[activeItem].mappingZones[tabID].textLines));
  $(elementPrefix + 'SwitchingTime').val(parseInt(serviceArrTmp[activeItem].mappingZones[tabID].switchingTime));

  if (serviceArrTmp[activeItem].mappingZones[tabID].wrapText) {
    $(elementPrefix + 'SwitchingTime').prop('disabled', false);
  } else {
    $(elementPrefix + 'SwitchingTime').prop('disabled', true).val(0);
  }
}

// Remove ZoneTab element
function removeZoneTab(tabZoneName) {
  $('#removeZoneTabText').html('Do you really want to remove the <b>' + tabZoneName + '</b> field?');
  $('#removeZoneTab').modal('show');

  $('#removeZoneTabBtn').on('click', function() {
    saveAllZoneTabs(); //save unsaved zones before remove
    var newArray = [];
    for (var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
      if (tabZoneName !== serviceArrTmp[activeItem].mappingZones[i].name) {
        newArray.push(serviceArrTmp[activeItem].mappingZones[i]);
      }
    }
    serviceArrTmp[activeItem].mappingZones = newArray;
    initZoneTabComponent();
    formChangedCallback();
  });
}

// Set active ZoneTab item
function setActiveZoneTab(tabName) {
  $('#customBoxTabs li a[id="LinkToText' + tabName + '"]').tab('show');
}

// Save ZoneTab
function saveZoneTabContent(tabID) {
  var tabName = serviceArrTmp[activeItem].mappingZones[tabID].name;
  var elementPrefix = '#textAndBackgroundText'+tabName;
  if(!$(elementPrefix + 'Name').hasClass('is-invalid')) { //if is not valid
    // First column
    serviceArrTmp[activeItem].mappingZones[tabID].name = $(elementPrefix + 'Name').val();
    serviceArrTmp[activeItem].mappingZones[tabID].pos_x = parseInt($(elementPrefix + 'PosX').val());
    serviceArrTmp[activeItem].mappingZones[tabID].pos_y = parseInt($(elementPrefix + 'PosY').val());
    saveTextTabContent(tabID, elementPrefix); // save all text fields
    serviceArrTmp[activeItem].mappingZones[tabID].wrapText = parseBool($(elementPrefix + 'WrapText').val());
    // Second column
    serviceArrTmp[activeItem].mappingZones[tabID].textWidth = parseInt($(elementPrefix + 'Width').val());
    serviceArrTmp[activeItem].mappingZones[tabID].textColor = hexToRgb($(elementPrefix + 'Color').val());
    serviceArrTmp[activeItem].mappingZones[tabID].font = $(elementPrefix + 'TextType').val();
    serviceArrTmp[activeItem].mappingZones[tabID].fontSize = parseInt($(elementPrefix + 'FontSize').val());
    serviceArrTmp[activeItem].mappingZones[tabID].textAlign = $(elementPrefix + 'Align').val();
    serviceArrTmp[activeItem].mappingZones[tabID].textVerticalAlign = $(elementPrefix + 'VAlign').val();
    serviceArrTmp[activeItem].mappingZones[tabID].textLines = parseInt($(elementPrefix + 'NumberOfLines').val());
    serviceArrTmp[activeItem].mappingZones[tabID].switchingTime = parseInt($(elementPrefix + 'SwitchingTime').val());
  }
}

// Save all ZoneTab
function saveAllZoneTabs() {
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    saveZoneTabContent(i);
  }
}

// Attach events to TabZone component
function attachEventsToZoneTabComponent() {

  // Button for increase nearest input value
  $('.increaseBtn').off('click').on('click', function(e) {
    e.preventDefault();
    let input = $(this).closest('.increaseDecreaseControlGroup').find('input');
    let maxVal = input.attr('max') || 10000000;
    let val = parseInt(input.val());

    if (val < maxVal) {
      input.val(val + 1).change();
    }
  });

  // Button for decrease nearest input value
  $('.decreaseBtn').off('click').on('click', function(e) {
    e.preventDefault();
    let input = $(this).closest('.increaseDecreaseControlGroup').find('input');
    let minVal = input.attr('min') || 0;
    let val = parseInt(input.val());

    if (val > minVal) {
      input.val(val - 1).change();
    }
  });

  $('.fontManagerBtn').off('click').on('click', showFontManagerCallback);

  // Add tab
  $('#addField').off('click').on('click', function(e) {
    e.preventDefault();
    var newTabId = serviceArrTmp[activeItem].mappingZones.length;
    newTabId = getNotExistingTabId(newTabId+1);
    var newData = { font: "classic", fontSize: 30, name: "field"+newTabId, pos_x: 10, pos_y: 10, switchingTime: 0, text: [{ source: "", active: true}], textAlign: "A_LEFT", textVerticalAlign: "VA_TOP", textColor: "255,0,0,1.0", textLines: 1, textWidth: 100, wrapText: false };
    serviceArrTmp[activeItem].mappingZones.push(newData);
    initZoneTabComponent();
    $('#customBoxTabs li:nth-child(' + newTabId + ') a').tab('show');
    formChangedCallback();
  });

  // Copy tab as a new one
  $('.copyField').off('click').on('click',function(e) {
    e.preventDefault();
    var tabName = $(this).attr('data-tab-name');
    var newTabId = serviceArrTmp[activeItem].mappingZones.length;
    newTabId = getNotExistingTabId(newTabId);
    for(var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
      if(serviceArrTmp[activeItem].mappingZones[i].name === tabName) {
        var newData = JSON.parse(JSON.stringify(serviceArrTmp[activeItem].mappingZones[i]));
      }
    }
    newData.name = "field"+(newTabId); //rename new tab
    serviceArrTmp[activeItem].mappingZones.push(newData); //push to mappingZones
    initZoneTabComponent();
    $('#customBoxTabs li:nth-child(' + newTabId + ') a').tab('show');
    formChangedCallback();
  });

  // Delete tab
  $('.removeLinkToText').off('click').on('click', function(e) {
    e.preventDefault();
    var tabName = $(this).attr('data-tab-name');
    removeZoneTab(tabName);
    $('#LinkToText'+tabName).off('click');
  });

  // Change tab name
  $('.changeName').off('change').on('change', function() {
    let thisVal = replaceSpecialChars($(this).val());
    if(!$(this).val().match(/[^a-zA-Z0-9]/g)) {
      if (detectExistingTabName($(this).attr('data-tab-name'), $(this).val())) {
        validateName($(this), true, 'Name "' + thisVal + '" already exists. Use unique name.');
        disableSaveBtn();
      } else {
        var newValue = $(this).val();
        $(this).attr('data-tab-name', newValue);
        validateName($(this), false, '');
        enableSaveBtn();
        saveAllZoneTabs();
        initZoneTabComponent($(this).attr('data-tab-name'));
      }
    }
  });

  // Disable switching time and set to 0 if wrapping text is NO
  $('.wrapText').off('change').on('change', function() {
    var tabName = $(this).attr('data-tab-name');
    var tabTextId = getActiveText(tabName);

    var toggle = ($(this).val() === 'true');
    var show = false;

    if($(this).val() === 'false' && $('textarea[data-text-id="'+tabTextId+'"]').val().indexOf("\n") > -1) show = true;
    toggleWrapMsg(tabName, tabTextId, show);
    toggleSwitchingTime(tabName, toggle);

    formChangedCallback();
  });

  // Changing values after typing to textarea
  $('#customBoxContent textarea').on('keyup', function() {
    formChangedCallback();
  });

  // Color palette changing input text color
  $('[id^=colorPaletteForText]').on('change',function() {
    var color = $(this).val();
    var input = $(this).prev(); // input text
    input.val(color);
    formChangedCallback();
  });

  // Input text color changing palette
  $('[id^=textAndBackgroundText]').on('change',function() {
    var color = $(this).val();
    var palette = $(this).next(); // palette
    palette.val(color);
    formChangedCallback();
  });

  // Change active state of box with click on tab
  $('[id^=LinkToText]').on('click', function() {
    highlightBox($(this).attr('data-tab-name'));
  });

  // Init tooltips in tab content
  $('body .tooltip').remove();
  $('#customBoxContent [title]').tooltip();
}

/***************************************************************/
/*                      Helper functions                       */
/***************************************************************/

function getActiveText(tabName) {
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    for( var o = 0; o < serviceArrTmp[activeItem].mappingZones[i].text.length; o++) {
      if (tabName === serviceArrTmp[activeItem].mappingZones[i].name) {
        if(serviceArrTmp[activeItem].mappingZones[i].text[o].active)
          tabTextId = "text" + (o+1);
      }
    }
  }
  return tabTextId;
}

function toggleSwitchingTime(tabName, disable) {
  if (disable) {
    $('.switchingTime[data-tab-name="' + tabName + '"]').prop('disabled', false);
  } else {
    $('.switchingTime[data-tab-name="' + tabName + '"]').prop('disabled', true).val(0);
  }
}

function toggleWrapMsg(tabName, textId, show) {
  if(show) {
    $('.wrapMsg[data-tab-name="' + tabName + '"][data-text-id="' + textId + '"]').text('Enable text wrapping for line breaks in live view.');
  } else {
    $('.wrapMsg[data-tab-name="' + tabName + '"][data-text-id="' + textId + '"]').text('');
  }
}

function validateName(element, show, invalidMsg){
  var validation = (show) ? 'is-invalid' : '';
  var invalidDiv = '<div class="invalid-feedback">' + invalidMsg + '</div>';

  if(validation === '') {
    element.removeClass('is-invalid');
    element.closest('.input-group').find('.invalid-feedback').remove();
  } else {
    element.addClass(validation);
    element.closest('.input-group').find('.invalid-feedback').remove();
    element.closest('.input-group').append(invalidDiv);
  }
}

// Detect if text param contains item with active param, if not set last one active
function detectNoActiveItem(services) {
  var activeFound = false;
  for(var i = 0; i < services.length; i++) {
    if(services[i].active) activeFound = true;
  }
  if(!activeFound) services[services.length - 1].active = true;

  return services;
}

// Get non existing ID for zoneTab
function getNotExistingTabId(tabCount) {
  var exists = false;
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    var name = serviceArrTmp[activeItem].mappingZones[i].name;
    if(name.indexOf(tabCount) > -1) exists = true;
  }
  if(exists) {
    return getNotExistingTabId(tabCount+1);
  } else {
    return tabCount;
  }
}

// Detect existing zoneTab name
function detectExistingTabName(activeTabName, tabName) {
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    if (activeTabName !== serviceArrTmp[activeItem].mappingZones[i].name) {
      if (tabName === serviceArrTmp[activeItem].mappingZones[i].name) return true;
    }
  }
  return false;
}

// Join color and opacity together to format rgba
function joinColorAndOpacity(colorInput, opacityInput) {
  var colorRGBA = hexToRgb(colorInput.val());
  var colorArray = colorRGBA.split(',');
  colorArray[3] = opacityInput.val() / 100;
  colorRGBA = colorArray.join(',');
  return colorRGBA;
}

// Get farthest X coordinates of mappingZone
function getMinWidth() {
  var maxWidth = 0;
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    var offsetX = serviceArrTmp[activeItem].mappingZones[i].pos_x + serviceArrTmp[activeItem].mappingZones[i].textWidth;
    if(maxWidth < offsetX) maxWidth = offsetX;
  }
  return maxWidth;
}

// Get farthest Y coordinates of mappingZone
function getMinHeight() {
  var maxHeight = 0;
  for(var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    var offsetY = serviceArrTmp[activeItem].mappingZones[i].pos_y + (serviceArrTmp[activeItem].mappingZones[i].fontSize * serviceArrTmp[activeItem].mappingZones[i].textLines);
    if(maxHeight < offsetY) maxHeight = offsetY;
  }
  return maxHeight
}

/***************************************************************/
/*                           Box                               */
/***************************************************************/

// Box events
$(document).on('boxLoaded', function(event, data) {
  var activeTab = $('#customBoxTabs li a.active').attr('data-tab-name');
  if(data.name === activeTab) {
    highlightBox(activeTab);
  }
}).on('boxMoved', function(event, data) {
  let new_pos_x = parseInt(data.pos_x) + parseFloat(data.move_x);
  let new_pos_y = parseInt(data.pos_y) + parseFloat(data.move_y);
  $('#textAndBackgroundText'+data.name+'PosX').val(parseInt(new_pos_x));
  $('#textAndBackgroundText'+data.name+'PosY').val(parseInt(new_pos_y));
  formChangedCallback();
}).on('boxResized', function(event, data) {
  $('#textAndBackgroundText'+data.name+'Width').val(parseInt(data.width));
  formChangedCallback();
});

// Attach events to all draw objects
function attachEventsToAllDrawObjects() {

  // Active state for box objects
  $('.boxIn').off('click').on('click', function(e) {

      var boxIn = $(this);

      if(e.shiftKey) {
        if(boxIn.hasClass('active')) {
          boxIn.removeClass('active');
        } else {
          boxIn.addClass('active');
        }
      } else {
        $('.boxIn').removeClass('active');
        boxIn.addClass('active');

        // Set active tab with settings
        setActiveZoneTab(boxIn.attr('data-name'));
      }
  });

  // Drag & resize for box objects
  interact('.boxIn.active').unset();
  interact('.boxIn.active').draggable({
    listeners: {
      start(event) {
        var items = $('.boxIn.active');
        for (var i = 0; i < items.length; i++) {
          var posX = items[i].style.left.replace('px', '');
          var posY = items[i].style.top.replace('px', '');

          // set starting position attributes
          items[i].setAttribute('data-x', posX);
          items[i].setAttribute('data-y', posY);
        }
      },
      move(event) {
        var items = $('.boxIn.active');
        for (var i = 0; i < items.length; i++) {

          const dataX = items[i].getAttribute('data-move-x');
          const dataY = items[i].getAttribute('data-move-y');
          const initialX = parseFloat(dataX) || 0;
          const initialY = parseFloat(dataY) || 0;
          const deltaX = event.dx;
          const deltaY = event.dy;
          const newX = initialX + deltaX;
          const newY = initialY + deltaY;


          // set new data-move position
          items[i].setAttribute('data-move-x', newX);
          items[i].setAttribute('data-move-y', newY);

          // translate the element
          items[i].style.transform = 'translate(' + newX + 'px, ' + newY + 'px)';

        }
      },
      end(event) {
        // fire event
        var items = $('.boxIn.active');
        for (var i = 0; i < items.length; i++) {
          $(document).trigger('boxMoved', [{
            name: items[i].getAttribute('data-name'),
            pos_x: items[i].getAttribute('data-x'),
            pos_y: items[i].getAttribute('data-y'),
            move_x: items[i].getAttribute('data-move-x'),
            move_y: items[i].getAttribute('data-move-y')
          }]);
        }
      }
    }
  }).resizable({
    // resize from all edges and corners
    edges: { left: true, right: true, bottom: false, top: false },
    modifiers: [
      // keep the edges inside the parent
      interact.modifiers.restrictEdges({ outer: 'parent', endOnly: true }),
      // minimum size
      interact.modifiers.restrictSize({ min: { width: 10, height: 10 } })
    ],
    inertia: true,
    listeners: {
      move(event) {
        let { x, y } = event.target.dataset;
        x = parseFloat(x) || 0;
        y = parseFloat(y) || 0;
        Object.assign(event.target.style, {
          width: `${event.rect.width}px`,
          height: `${event.rect.height}px`,
          transform: `translate(${event.deltaRect.left}px, ${event.deltaRect.top}px)`
        });
        Object.assign(event.target.dataset, { x, y })
      },
      end(event) {
        // fire event
        $(document).trigger('boxResized', [{
          name:  event.target.getAttribute('data-name'),
          width: event.target.style.width.replace('px','')
        }]);
      }
    }
  });
}

// Draw all box objects
function drawAll(inElement) {
  eraseAll(inElement); // Remove prev box objects
  for (var i = 0; i < serviceArrTmp[activeItem].mappingZones.length; i++) {
    var box = createBox(serviceArrTmp[activeItem].mappingZones[i]);
    inElement.append(box);

    $(document).trigger('boxLoaded', [{ name: box.attr('data-name') }]);
  }
  attachEventsToAllDrawObjects();
}

// Erase all box objects
function eraseAll(inElement) {
  inElement.find('.boxIn').remove();
  inElement.find('.boxIn').off();
}

// Create box object
function createBox(params) {
  var color = 'rgba('+ params.textColor + ')';
  var textElement = createBoxText(params);
  var labelElement = $('<span id="label"></span>').text(params.name);
  var box = $('<div data-name="' + params.name + '" class="boxIn"></div>');
  box.css({
    width: params.textWidth,
    color: color,
    display: "flex",
    top: params.pos_y + "px",
    left: params.pos_x + "px",
    height: (params.fontSize * params.textLines) + 16 + "px",
  });
  box.append(labelElement);
  box.append(textElement);
  return box;
}

// Highlight box object
function highlightBox(name) {
  $('.boxIn').removeClass('active');
  $('.boxIn[data-name="' + name + '"]').addClass('active');
}

// Create text for Box
function createBoxText(params) {
  var text = '';
  var color = 'rgba('+ params.textColor + ')';
  for (var i = 0; i < params.text.length; i++) {
    if (params.text[i].active) {
      text = (params.text[i].source !== '') ? params.text[i].source : '';
    }
  }
  var wrapText = "nowrap";
  if (params.wrapText) {
    wrapText = "pre-wrap";
  }
  if (text.indexOf("\n") > -1) {
    wrapText = "pre-wrap";
  }
  var boxText = $('<div id="text"></div>');
  let height = ((params.fontSize * params.textLines) + 8) + "px";
  if (params.textLines > 1) {
    height = "auto";
  }
  boxText.css({
    display: "flex",
    whiteSpace: wrapText,
    width: "100%",
    color: color,
    fontSize: params.fontSize + "px",
    lineHeight: (params.fontSize + 4) + "px",
    justifyContent: getHorizontalAlignValue(params.textAlign),
    alignItems: getVerticalAlignValue(params.textVerticalAlign),
    textAlign: getAlignValue(params.textAlign),
    textOverflow: "ellipsis",
    height: height,
    overflow: "hidden"
  }).text(text);
  return boxText;
}

function getAlignValue(textAlign) {
  if (textAlign === 'A_LEFT') {
    return 'left';
  } else if (textAlign === 'A_CENTER') {
    return 'center'
  } else if (textAlign === 'A_RIGHT') {
    return 'right';
  } else {
    return 'left';
  }
}

function getHorizontalAlignValue(textAlign) {
  if (textAlign === 'A_LEFT') {
    return 'flex-start';
  } else if (textAlign === 'A_CENTER') {
    return 'center'
  } else if (textAlign === 'A_RIGHT') {
    return 'flex-end';
  } else {
    return 'flex-start';
  }
}

function getVerticalAlignValue(textVerticalAlign) {
  if (textVerticalAlign === 'VA_TOP') {
    return 'flex-start';
  } else if (textVerticalAlign === 'VA_CENTER') {
    return 'center';
  } else if (textVerticalAlign === 'VA_BOTTOM') {
    return 'flex-end';
  } else {
    return 'flex-start';
  }
}
/***************************************************************/

function formChangedCallback() {



  if (serviceArrTmp[activeItem].name == "textAndBackground") {
    serviceArrTmp[activeItem].name = "customGraphics";
  }
  serviceArrTmp[activeItem].customName = $('#textAndBackgroundCustomName').val();
  serviceArrTmp[activeItem].clockFormat = $('#textAndBackgroundRadioClock').val();
  let currentCameraResolutionObject = cameraResolutions[parseInt($('#textAndBackgroundResolution').val())];
  serviceArrTmp[activeItem].width = currentCameraResolutionObject.width;
  serviceArrTmp[activeItem].height = currentCameraResolutionObject.height;
  serviceArrTmp[activeItem].background = $('#textAndBackgroundMappingArea').val();
  serviceArrTmp[activeItem].image = $('#textAndBackgroundImage').val();
  serviceArrTmp[activeItem].coordSystem = $('#textAndBackgroundPosition').val();
  serviceArrTmp[activeItem].automationType = $('#textAndBackgroundAutomationType').val();
  serviceArrTmp[activeItem].pos_x = parseInt($('#textAndBackgroundPosX').val());
  serviceArrTmp[activeItem].pos_y = parseInt($('#textAndBackgroundPosY').val());

  saveAllZoneTabs(); // Save all zoneTabContent
  saveCustomBoxSettings(); // Save customBoxSettings
  drawAll($('#mappingAreaType')); // Redraw mappingAreaType with .boxIn

  serviceArrTmp[activeItem].camera = saveVideoChannelValue(serviceArrTmp[activeItem].camera, $('#textAndBackgroundVideoChannel'));
  createCameraPreview($('#textAndBackgroundVideoChannel'), currentCameraResolutionObject, serviceArrTmp[activeItem].camera);

  showSaveWarning();
  createServiceList(serviceArrTmp);
}



