var arrSuggestion = [];

$(document).ready(function() {

  //init tooltips
  initTooltips();
  initVideoChannel();
  initServiceId();

  // Change font select & image select (file manager) after close modal
  $('body').off('hide.bs.modal').on('hide.bs.modal', '#fileManagerModal', function() {
    createFontList('#infotickerTextType', serviceArrTmp[activeItem].font);
    createImageList('#customImage', true, serviceArrTmp[activeItem].image);
  });

  $('#infotickerLocationName').on('change',function(){
    validate($(this),'','Enter a city name.');
  });

  $('#infotickerSourceType').on('change',function(){
    var infotickerSourceTypeValue = $(this).val();
    if(infotickerSourceTypeValue === 'text'){
      $('#infotickerSource-text').show();
      $('#infotickerSource').attr('placeholder','Use Enter to break the line');
    }else{
      $('#infotickerSource-text').hide();
      $('#infotickerSource').attr('placeholder','Use UTF coding in TXT file.');
    }
  });

  $('#infotickerLocationName').typeahead({
    source: getLocationDataToSuggest,
    updater: function(item){
      city = item.split(',');
      administrativeArea = city[1].trim();
      for (var i = 0; i < arrSuggestion.length; i++) {
        if(arrSuggestion[i].LocalizedName === city[0] && arrSuggestion[i].AdministrativeArea.LocalizedName === administrativeArea) {
          serviceArrTmp[activeItem].weatherLocation = arrSuggestion[i].Key;
          serviceArrTmp[activeItem].weatherLocationName = arrSuggestion[i].LocalizedName;
          renderMap();
          return arrSuggestion[i].LocalizedName;
        }
      }
    },
    items: 'all'
  });

  $('#colorPaletteForTextColor').on('change',function(){
    var color = $(this).val();
    $('#infotickerTextColor').val(color);
  });

  $('#infotickerTextColor').on('change',function(){
    var color = $(this).val();
    $('#colorPaletteForTextColor').val(color);
  });

  $('#colorPaletteForBgColor').on('change',function(){
    var color = $(this).val();
    $('#infotickerBgColor').val(color);
  });

  $('#infotickerBgColor').on('change',function(){
    var color = $(this).val();
    $('#colorPaletteForBgColor').val(color);
  });

  if (!isMips()) {
    $('.infotickerCrawlLeft').show();
    $('#infotickerCrawlLeft').on('change', function () {
      var infotickerCrawlLeftValue = $(this).val();
      if (infotickerCrawlLeftValue === "No") {
        $('#infotickerSwitchingTime').prop('disabled', false);
        $('#infotickerNumberOfLines').prop('disabled', false);
      } else {
        $('#infotickerSwitchingTime').prop('disabled', true);
        $('#infotickerNumberOfLines').val(1);
        $('#infotickerNumberOfLines').prop('disabled', true);
      }
    });
  } else {
    $('.infotickerCrawlLeft').hide();
  }

  // Fill form
  Switch().init('infotickerEnabled');

  $('#infotickerCustomName')
    .val(serviceArrTmp[activeItem].customName || '')
    .keyup(onCustomNameKeyUp)
    .attachValidation({
      pattern: '^[A-Za-z0-9 -]{0,}$',
      invalidMsg: 'Only chars A-Z, a-z, 0-9, white space and dash are allowed.',
      disableBtnId: 'saveBtn'
    });
  $('#infotickerLocationName').val(serviceArrTmp[activeItem].weatherLocationName);
  $('#infotickerPosition').val(serviceArrTmp[activeItem].coordSystem || 'bottom');
  $('#infotickerPosY').val(convertFloatToPercentage(serviceArrTmp[activeItem].pos_y || 0.05));

  $('#infotickerShowClock').val(serviceArrTmp[activeItem].showClock ? "Yes" : "No");

  if (serviceArrTmp[activeItem].clockType != undefined) {
    $('#infotickerRadioClock').val(serviceArrTmp[activeItem].clockType).change();
  }
  if (serviceArrTmp[activeItem].textColor != "" && serviceArrTmp[activeItem].textColor != undefined) {
    var textColor = rgbToHex(serviceArrTmp[activeItem].textColor);
    $('#infotickerTextColor').val(textColor);
    $('#colorPaletteForTextColor').val(textColor);
  }
  let infotickerBgOpacity = $('#infotickerBgOpacity');
  if (serviceArrTmp[activeItem].bgColor != "" && serviceArrTmp[activeItem].bgColor != undefined) {
    var bgColor = rgbToHex(serviceArrTmp[activeItem].bgColor);
    let bgOpacity = getOpacity(serviceArrTmp[activeItem].bgColor);
    $('#infotickerBgColor').val(bgColor);
    $('#colorPaletteForBgColor').val(bgColor);
    infotickerBgOpacity.val(bgOpacity);
  }
  // Opacity input change text with %
  infotickerBgOpacity.next().find('.input-group-text').first().text(infotickerBgOpacity.val());
  infotickerBgOpacity.on('change mousemove', function() {
    $(this).next().find('.input-group-text').first().text($(this).val());
  });

  if(serviceArrTmp[activeItem].sourceType == ""){
    $('#infotickerSourceType').val('text').change();
  } else {
    $('#infotickerSourceType').val(serviceArrTmp[activeItem].sourceType).change();
  }
  if(serviceArrTmp[activeItem].sourceType === 'text'){
    $('#infotickerSource-text').show();
  }
  $('#infotickerSource').val(serviceArrTmp[activeItem].source);
  createFontList('#infotickerTextType', serviceArrTmp[activeItem].font);
  $('#infotickerFontSize').val(parseInt(serviceArrTmp[activeItem].fontSize));
  $('#infotickerLanguage').val(serviceArrTmp[activeItem].weatherLang);
  $('#infotickerUnits').val(serviceArrTmp[activeItem].weatherUnits);
  $('#infotickerSwitchingTime').val(serviceArrTmp[activeItem].switchingTime);

  if (!isMips()) {
    //if yes, disable switchingTime and NumberOfLines
    if (!serviceArrTmp[activeItem].crawlLeft) {
      $('#infotickerCrawlLeft').val("No");
      $('#infotickerSwitchingTime').prop('disabled', false);
      $('#infotickerNumberOfLines').prop('disabled', false);
    } else {
      $('#infotickerSwitchingTime').prop('disabled', true);
      $('#infotickerNumberOfLines').val(1);
      $('#infotickerNumberOfLines').prop('disabled', true);
      const covert_speed_to_value = {
        1: "Slow",
        2: "Medium",
        4: "Fast",
      };
      const unknown_speed = covert_speed_to_value[serviceArrTmp[activeItem].crawlSpeed] == undefined;
      if (unknown_speed) {
        throw Error('Unknown speed of crawl left.');
      }
      $('#infotickerCrawlLeft').val(covert_speed_to_value[serviceArrTmp[activeItem].crawlSpeed]);
    }
  }

  $('#infotickerNumberOfLines').val(serviceArrTmp[activeItem].numberOfLines);

  const resolutionId = '#infotickerResolution';
  const videoChannelId = '#infotickerVideoChannel';
  createResolutionList(resolutionId);
  createTriggeringElement('#infotickerAutomationType', serviceArrTmp[activeItem].automationType, serviceArrTmp[activeItem].schedule);
  onVideoChannelChange(resolutionId, videoChannelId, serviceArrTmp[activeItem].camera);
  createVideoChannelElement(videoChannelId, serviceArrTmp[activeItem].camera).then(function(){
    // Callbacks for changes
    $('#infotickerLocationName').on('change',formChangedCallback());
    $('.form-control').change(formChangedCallback);
    $('.form-control-inline').change(formChangedCallback);
    $('.fontManagerBtn').click(showFontManagerCallback);

    formChangedCallback();
  });

  createScheduleBtn();
});

async function formChangedCallback() {
  serviceArrTmp[activeItem].customName = $('#infotickerCustomName').val();

  serviceArrTmp[activeItem].showClock = $('#infotickerShowClock').val() == 'Yes' ? 1 : 0;
  serviceArrTmp[activeItem].clockType = $('#infotickerRadioClock').val();
  serviceArrTmp[activeItem].textColor = hexToRgb($('#infotickerTextColor').val());
  let bgColor = hexToRgb($('#infotickerBgColor').val());
  let bgOpacity = $('#infotickerBgOpacity').val();
  serviceArrTmp[activeItem].bgColor = getBgColor(bgColor, bgOpacity);
  serviceArrTmp[activeItem].weatherLang = $('#infotickerLanguage').val();
  serviceArrTmp[activeItem].weatherLocationName = $('#infotickerLocationName').val();
  serviceArrTmp[activeItem].sourceType = $('#infotickerSourceType').val();
  serviceArrTmp[activeItem].font = $('#infotickerTextType').val();
  serviceArrTmp[activeItem].fontSize = parseInt($('#infotickerFontSize').val());
  serviceArrTmp[activeItem].source = $('#infotickerSource').val();
  serviceArrTmp[activeItem].numberOfLines = parseInt($('#infotickerNumberOfLines').val());
  serviceArrTmp[activeItem].switchingTime = parseInt($('#infotickerSwitchingTime').val());

  if (!isMips()) {
    let infoTickerCrawlLeftValue = $('#infotickerCrawlLeft').val();
    const crawl_left_on = infoTickerCrawlLeftValue !== "No";
    serviceArrTmp[activeItem].crawlLeft = crawl_left_on;
    if (crawl_left_on) {
      const covert_value_to_speed = {
        "Slow" : 1,
        "Medium": 2,
        "Fast": 4,
      };
      const unknown_value = covert_value_to_speed[infoTickerCrawlLeftValue] == undefined;
      if (unknown_value) {
        throw Error('Unknown value of crawl left.');
      }
      serviceArrTmp[activeItem].crawlSpeed = covert_value_to_speed[infoTickerCrawlLeftValue];
    }
  }

  serviceArrTmp[activeItem].weatherUnits = $('#infotickerUnits').val();
  serviceArrTmp[activeItem].automationType = $('#infotickerAutomationType').val();
  let currentCameraResolutionObject = cameraResolutions[parseInt($('#infotickerResolution').val())];
  serviceArrTmp[activeItem].width = currentCameraResolutionObject.width;
  serviceArrTmp[activeItem].height = currentCameraResolutionObject.height;
  serviceArrTmp[activeItem].coordSystem = $('#infotickerPosition').val();
  serviceArrTmp[activeItem].pos_y = convertPercentageToFloat($('#infotickerPosY').val(), 5);
  serviceArrTmp[activeItem].camera = saveVideoChannelValue(serviceArrTmp[activeItem].camera, $('#infotickerVideoChannel'));
  createCameraPreview($('#infotickerVideoChannel'), currentCameraResolutionObject, serviceArrTmp[activeItem].camera);

  showSaveWarning();
  createServiceList(serviceArrTmp);
}

/**
 *
 * @param color - rgba format
 * @returns {number} - opacity (0-100)
 */
function getOpacity(color) {
  let colorArr = color.split(",");
  return colorArr[3] * 100;
}

/**
 *
 * @param color - rgba format
 * @param opacity - interval 0-100
 * @returns {string} - rgba format
 */
function getBgColor(color, opacity) {
  color = color.split(",");
  color.pop();
  opacity = opacity / 100;
  color.push(opacity);
  return color.join(",");
}

function getLocationDataToSuggest(query, result) {

  var lang = serviceArrTmp[activeItem].weatherLang;
  while(arrSuggestion.length > 0) {
    arrSuggestion.pop();
  }
  $.ajax({
    url: 'https://camstreamer.com/index.php?p=CamOverlay&a=AccuWeatherProxy&serial_number=' + serialNumber + '&q='+ encodeURIComponent('/locations/v1/cities/autocomplete?q=' + encodeURIComponent(query) + '&language='+encodeURIComponent(lang)),
    dataType: "json",
    type: "GET",
    success: function (data) {
      result($.map(data, function (item) {
        arrSuggestion.push(item);
        return item.LocalizedName + ", " + item.AdministrativeArea.LocalizedName  +  ", " + item.Country.LocalizedName;
      }));
    }
  });
}

function hexToRgb(hex){
  var c;
  if(/^#([A-Fa-f0-9]{3}){1,2}$/.test(hex)){
    c= hex.substring(1).split('');
    if(c.length== 3){
      c= [c[0], c[0], c[1], c[1], c[2], c[2]];
    }
    c= '0x'+c.join('');
    return [(c>>16)&255, (c>>8)&255, c&255].join(',')+',1';
  }else{
    throw new Error('bad HEX input');
  }
}

function rgbToHex(rgb){
  rgb = rgb.match(/^[\s+]?[\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?/i);
  if(rgb && rgb.length === 4){
    var hex =  "#" + ("0" + parseInt(rgb[1],10).toString(16)).slice(-2) +
      ("0" + parseInt(rgb[2],10).toString(16)).slice(-2) +
      ("0" + parseInt(rgb[3],10).toString(16)).slice(-2);
    return hex;
  }else{
    throw new Error('bad RGBA input');
  }

}



