const Configuration = () => {

  const getEnabledServices = () => {
    return serviceArrTmp.filter((service) => service.enabled === 1).length;
  }

  const getEnabledServicesPerChannel = () => {
    return serviceArrTmp.filter((service) => service.enabled === 1 && serviceArrTmp[activeItem].camera === service.camera).length;
  }

  const config_ui_messages = {
    maxAllowedMessage: 'Maximally four services can be enabled simultaneously in one Video Channel and eight services can run in total.',
    maxAllowedMessageMIPS: 'Maximally two services can be enabled simultaneously.',
    canAddNewService: 'Three or four active services in one Video Channel in CamOverlay App could be in conflict with Axis overlay.',
  }

  const getMaxAllowedMessage = async () => {
    return !isMips() ? config_ui_messages.maxAllowedMessage : config_ui_messages.maxAllowedMessageMIPS;
  }

  const getAddNewServiceMessage = async () => {
    return config_ui_messages.canAddNewService;
  }

  const exceedsMaxServiceCount = async () => {
    const enabled_services_count = getEnabledServices();
    const enabled_services_per_video_channel = getEnabledServicesPerChannel();

    if (!isMips()) {
      if (enabled_services_count > 8 || enabled_services_per_video_channel > 4) {
        return true;
      }
    } else {
      if (enabled_services_count > 2) {
        return true;
      }
    }
    return false;
  }

  const canEnableAnotherService = async () => {
    const enabled_services_count = getEnabledServices();
    const enabled_services_per_video_channel = getEnabledServicesPerChannel();

    if (!isMips()) {
      if (enabled_services_count >= 8 || enabled_services_per_video_channel >= 4) {
        return false;
      }
    } else {
      if (enabled_services_count >= 2) {
        return false;
      }
    }
    return true;
  }

  const canAddNewService = async () => {
    const enabled_services_count = getEnabledServices();
    if (!isMips()) {
      if (enabled_services_count === 2 || enabled_services_count === 3) {
        return false;
      }
    }
    return true;
  }

  return {
    canEnableAnotherService,
    exceedsMaxServiceCount,
    getMaxAllowedMessage,
    canAddNewService,
    getAddNewServiceMessage,
  }
}